/*
  Designed by Linjianghua(Xempo) 2004-2006, 2012, 2014
  Free under LGPL
*/

#include <string.h>
#include "stdfun.h"
#include "dirext.h"
#include "script.h"
#include "infor.h"

#include "dirloop.c"

char *pdPathNam(fsp_dir *dir,fsp_dir *lmt,int msg)
{/* msg: 0 lmt only opening-dir; 1 limit all sub, 2 include itself */
char *pth, *ptr;
fsp_dir *dir1;
dskadr_t adr;
if(lmt&&lmt->own_adr==dir->own_adr&&msg)return strdup(dir->name);
adr=dir->parent_adr;
switch(adr){
case 0 : return msg ? strdup(dir->name) : catstr(rootchs, dir->name, 0);
case 1 : return strdup(rootchs);
}
pth=strdup(dir->name);
do{
   if(lmt&&lmt->own_adr==adr){
	if(msg==1)break;
	dir1=lmt;
	}
   else dir1=pdRead(dir->lib, NULL, adr);
   ptr=pth;
   pth=catstr(dir1->name,pth, '/');
   free(ptr);
   if(msg==2&&dir1==lmt)break;
   adr=dir1->parent_adr;
   if(dir1!=lmt)pd_close(dir1, 2); /* don't change above 3 line easily */
}while( adr>1 );

if(adr<2&&msg==0){
	ptr=catstr(rootchs,pth,'/');	free(pth);
	return ptr;
	}
return pth;
}

BOOL ChDire(fsp_lib *lib, char *dirname,int sel)
{/* if use rt=False and use return rt, it would more large mem for use */
fsp_dir *dir1;
if(dirname==NULL)return True;
if(dirname[1]==0)
  switch(dirname[0]){
  case '*' : 
	if(diguei && isRS){
		dir1= lib->bakdir_adr ? pdRead(lib, NULL, lib->bakdir_adr) : (fsp_dir *)lib;
		goto _jmp_;
	}
  case '.' : return True;
  case '/' :
  case '\\' : lib->CurDir=(fsp_dir *)lib;
	return True;
  }

dir1=DirOpen(lib->CurDir,dirname);
if(idxdscpt>0x7ffd){
_jmp_:    if(dir1!=lib->CurDir){
	lib->bakdir_adr=lib->CurDir->own_adr;
	pd_close(lib->CurDir,2);
	lib->CurDir=dir1;
	lib->mdf|=OnlyChDir; /* (128)not last mdf, no chtime */
	return True;
   }
   if(sel>0)return True;
}
else reportBug();
return False;
}
