/*
	Write by xempo 9 2014
	Free under LGPL
*/

#ifndef  Financ_Stocks
#define  Financ_Stocks

#include "person.h"

#define  StocksDAU  6

typedef struct _fieldNode {
LVItem *it;
int num, dyNum;
bool mdf;
}FieldNode;

class FinaStocks : public Person
{
 moc_Object

friend int readNum(fsp_dir *dir, BYTE *unit);

public:
   FinaStocks( QWidget* parent);
//   ~FinaStocks();

virtual  bool exe(const char *cap, int id, int cn, const char **lst, int img);

protected :
virtual  bool event(QEvent *e);

private:
const char **_stocks_;
QAction *subAddAct, *buyAct, *priceAct, *cashInAct, *cashOutAct;
FieldNode *fieldNodes;
int nodCnt, nodPre;
FieldNode *tash;
int tashCnt, tashPre;
fsp_dir *StocksDir;
QTextCodec *utf8code;
bool mdf;
float dyAchie;
int mdf_val, dyAchieCount, orgPrice, Cnt,
	tms, tmId;
long long moneyInOut, money, exchangVal, stockNum,
	t_Money, surplusVal, t_stocksVal, t_exchangVal;
char pricBuf[80], numBuf[80];
bool fspSave();

LVItem *lastStocks();
LVItem *subFieldCreat(LVItem *it, LVItem *sit, const char *chs, int field, MAU *);
LVItem *backSibling(LVItem *it, int *);
void creatCountField();
void mdfCountField(int lmt=5);
int getMoney(const char *txt);
LVItem *getField(LVItem *it0, int idx);
LVItem *getStocks();
FieldNode *getNode(LVItem *stocks);
void priceCount(int sw, LVItem *field, int recprice);
void exchangCount(LVItem *stock1);
void subCount(LVItem *it0);
void achieCount(LVItem *achiefield);
int readNumb(fsp_dir *dir, BYTE *unit);
};

extern const char fspStocks[];
extern QPtrList <FinaStocks> stocksList;

#endif
