/*
	Write & edit by Linjianghua 2005-06,2008-2010, 2012
	Free under LGPL
*/

#include "fspdir.h"
#include "infor.h"

void dOperStat(fsp_lib *lib,char **pm, int nCom)
{
  char *dname;
  fsp_dir *dir=pdParent(lib->CurDir,*pm, &dname);
  if(idxdscpt>0x7ffd){
	switch(nCom){
	case FSP_erase :
	case FSP_ndels :
	case FSP_empty : /* dname=(char *)DirOpen(dir,dname); cvt to send */
	case FSP_del :
	case FSP_rmdir : pdDel(dir,dname,nCom);
		break;
	case FSP_ren :
	case FSP_rendir : pdRen(dir,dname,pm[1]);
	}
	pd_close(dir,1);
  }
  else reportBug();
}

void nOperStat(fsp_lib *lib,char **pm, int nCom)
{
  int numb;
  BOOL rt;
  fsp_dir *dir=pd_open(lib->CurDir,divPath(*pm,&numb), DIR_WRITE);
  if(idxdscpt>0x7ffd){
	switch(nCom){
	case FSP_ren : 
	case FSP_rename : rt=num_ren(dir,numb,atol(pm[1]));
		break;
	case FSP_erase :  del_mode=FSP_erase;
	default : rt=num_del(dir,numb); /* 2105, 2106=rm */
	}
	if(rt==False)reportBug();/* num 实时报错，不同dir, it loop */
	pd_close(dir,1);
  }
  else reportBug();
}

void pdUndel(fsp_lib *lib,char *dirnam)
{
  fsp_dir *dir=pd_open(lib->CurDir,dirnam,DIR_READ);
  if(idxdscpt>0x7ffd){
    DirFCU *du1;
     if((du1=pdSeek(dir,(char *)SPC, DIR_RESCUE))!=NULL){
	if(undelPd(dir, du1)){
		_step=1;
	     if(FCU_pdModify(dir, du1, DIR_RESCUE)==1){
		if(getMsg){
			char buf[1024];
			sprintf(buf, "  Rescue dir : <font color=#a94030><u> %s </u></font>",du1->name);
			msgShow(buf);
			}
		else printf("  Rescue dir : \033[7m%s\033[0m\n",du1->name);
		}
		}
	free(du1);
    }
    else DefaultManu( NoRescuDir_25 );
    pd_close(dir,1);
  }
  else reportBug();
}

int NumbUndel(fsp_lib *lib,char *dirnam, int n )
{
  fsp_dir *dir=pd_open(lib->CurDir,dirnam,DIR_READ);
  int rt=0;
  if(idxdscpt>0x7ffd){
    BYTE *unit;
    if((unit=seekFCU(dir,0,NULL,NUMB_RESCUE))!=NULL){
	rt=undelNum(dir, unit,  lib->FCU_dyw);
	if(rt==1){
		if(getMsg){
			char buf[80];
			sprintf(buf, "  Rescue %d", isZero(dir->Format) ? dir->NumbForZero:*(int *)(unit+FCU_NumPos));
			msgShow(buf);
			}
		else printf("  Rescue %d\n", isZero(dir->Format) ? dir->NumbForZero:*(int *)(unit+FCU_NumPos));
	}
	free(unit);
	}
    else if(n<1)DefaultManu(NoReCover_23);
    pd_close(dir,1);
  }
  else reportBug();
return rt;
}

