/*
	Write & edit by Linjianghua 2005-06,2008-2010, 2014
	Free under LGPL
*/

#include "normal.h"
#include "fsptime.h"
#include "fspdir.h"
#include "dirext.h"
#include "script.h"
#include "shellcom.h"
#include "write.h"
#include "conspace.h"
#include "input.h"
#include "dirloop.h"
#include "fcu.h"
#include "infor.h"
#include "dlist.h"
#include "stdfun.h"
#include "jxswitch.h"

#ifdef  _Simple_Base_
#include "init.h"
#include "simplebase.h"
#else
#include "init.c"
#endif

int main(int argc,char **argv)
{
int i, rt=0 /* for make */;
fsp_lib *lib=NULL;
char *ptr;
static const char fmt0[]="%s]", fmt1[]="%s #";
printf("\033[2J\033[1;1H");
printf("\t\033[34m%s\033[0m\n", fspVer);

#ifdef  _Simple_Base_
pGetPdExt=GetExtDir;
#endif

  popMsg=putmsg;  	msgShow=puts;
  PrnTxt=outTxt;
  i=init(&argc, argv, "--lang,--help,-h");
  if(conVal>0)fspHB(Readme_31, 0);
  switch(i){
  case ini_first : // first
	if(conVal==0)fspHB(Readme_31, 0);
  case ini_norm : {
	time_t tm;
	time(&tm);
	sprintf(InpBuf, "fsplus init: %s", ctime(&tm) );
	}
	RunLog(InpBuf);
	if((ptr=sysIdRead(*workspace, CONFIG_ID))!=NULL){ /* fspconf */
	    setCfgVal(ptr);
	    free(ptr);
	}
	if(argc>1)for(i=1; i<argc; i++)lib=comRun(lib, argv[i], 0, NULL);
	else if((ptr=sysIdRead(*workspace, AUTORUN_ID))!=NULL){/* fspinit */
		fmtvalue(ptr, 1); /* rem "" sybm for UseFile */
		lib=fspScript(NULL, ptr, 0, NULL);
		free(ptr);
		}

  while(CommNumb!=FSP_exit){
   if(CommNumb==FSP_quit /* extern runing-msg */){
	rt=-1;	goto _ex_;
	}
    if(lib){
      char *pth=pdPathNam(lib->CurDir,NULL,0);
      printf( ((lib->CurDir->Format&SimpleBase)? fmt1:fmt0), pth);
      free(pth);
    }
    else printf(". ");
    *InpBuf=0;
     inCon(InpBuf, 2047);
     runinginfo=0;      CommNumb=-20;
     kRescue=0; kRedir=0; OverWrite=0;
     lib=comRun(lib, InpBuf, 0, NULL ); /* set CommNumb */
  }
_ex_: for(i=LASTSPACE;i>-1;i--)if(workspace[i])fspDestroy(workspace[i], NULL);
 break;
 case ini_notfsp : PrnTxt(1,4,fspKern);
 case ini_nocom : 
 case ini_notinst : printf(pInfo, rtfn);
 }
return rt;  /* for make */
}
