/*
	Write by xempo Nov 2015
	Free under LGPL
*/

#include "peconf.h"

const char PEconf[]="PEconf";

TWPE::TWPE(QWidget *par, int idx) : TabWdg(par, idx)
{
}

void TWPE::closing()
{
int i;
ProEdit *pe2, *pe=(ProEdit *)(topLevelWidget()->parentWidget());
TabWdg::closing();
pe->setFnt(comboFont->currentText(), comboSize->currentText(),
	boldChk->isChecked(), italicChk->isChecked(), underlineChk->isChecked());
for(i=0; i<proEditList.count(); i++){
	pe2=proEditList.at(i);
	if(pe!=pe2)pe2->setFnt(comboFont->currentText(), comboSize->currentText(),
			boldChk->isChecked(), italicChk->isChecked(), underlineChk->isChecked());
	}
}


/*_________________________ ProEdit config ________________________ */

PEConf *PEcfgs;
PEConf::PEConf(QWidget *par, const char *nam) : SettingWidget(par, nam)
{
}

void PEConf::execu(const int w, const int h, const int id)
{
SettingWidget::execu(w,h,id);
tab=new TWPE(tabwdg, 54);
tab->init(_setting_+3, tabw, fntSz, proEditFontId);
show();
}

static QMetaObjectCleanUp cleanUp_PEConf( PEconf, &PEConf::staticMetaObject );

QMetaObject *PEConf::metaObj = 0;
QMetaObject* PEConf::staticMetaObject()
{
  if ( !metaObj ){
    static const QMetaData slot_tbl[] = {
	{ "Sure()" , &slot_0_0, QMetaData::Private },
	{ "pReturn()" , &slot_0_0, QMetaData::Private }
    };
    metaObj = QMetaObject::new_metaobject( PEconf, QWidget::staticMetaObject(), slot_tbl, 2,
	0, 0,
#ifndef QT_NO_PROPERTIES
	0, 0,
	0, 0,
#endif // QT_NO_PROPERTIES
	0, 0 );
    cleanUp_PEConf.setMetaObject( metaObj );
    }
  return metaObj;
}

#ifndef QT_NO_PROPERTIES
bool PEConf::qt_static_property( QObject* , int , int , QVariant* ){ return false; }
#endif // QT_NO_PROPERTIES

bool PEConf::qt_invoke( int _id, QUObject* _o )
{
int  sw=_id - staticMetaObject()->slotOffset();
switch(sw){
case 0 :
case 1 : tab->closing();
	close();
	PEcfgs=NULL;
	break;
default : return QWidget::qt_invoke( _id, _o );
}
return true;
}
